﻿
Option Strict On
Imports System.Xml.Linq
Imports System.Windows.Data

Public Class PersonalInfo
    Property 氏名 As String
    Property 年齢 As String
    Property 住所 As String
    Property 勤務先 As String
End Class

Public Class ImageInfo
    Property 画像名 As String
End Class

Partial Public Class TransitionEffectElementShow
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
    End Sub

    Dim no As Integer = 0
    Private Sub TransitionEffectElementShow_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        RichTextBoxShow()
        ImageShow()
        DataGridShow()
    End Sub

    Private Sub RichTextBoxShow()
        Dim xmldoc As XElement = XElement.Load("WilliamBlake.xml")
        Dim title As String = xmldoc.Descendants("タイトル").Value
        Dim author As String = xmldoc.Element("情報").Element("タイトル").Attribute("著者").Value
        Dim contents As String = xmldoc.Descendants("内容").Value

        Dim myParagraph As New Paragraph

        Dim titleRun1 As New Run
        With titleRun1
            .Text = title
            .FontSize = 20
            .FontWeight = FontWeights.Bold
            .Foreground = New SolidColorBrush(Colors.Red)
        End With

        Dim authorRun2 As New Run
        With authorRun2
            .Text = author
            .FontSize = 16
            .FontWeight = FontWeights.Bold
            .Foreground = New SolidColorBrush(Colors.Blue)
        End With

        Dim myLinebreak As New LineBreak
        myParagraph.Inlines.Add(myLinebreak) '改行

        Dim contentsRun3 As New Run

        With contentsRun3
            .Text = contents
            .FontSize = 11
        End With

        With myParagraph.Inlines
            .Add(titleRun1)
            .Add(authorRun2)
            .Add(contentsRun3)
        End With

        WilliamBlake_RichTextBox.Blocks.Add(myParagraph)

        Dim startPointer As TextPointer = WilliamBlake_RichTextBox.ContentStart.GetNextInsertionPosition(LogicalDirection.Forward)
        WilliamBlake_RichTextBox.Selection.Select(startPointer, startPointer)
    End Sub




    Private Sub DataGridShow()
        '■DataGrid処理

        Dim myPersonalInfo As New List(Of PersonalInfo)

        Dim xmldoc2 As XElement = XElement.Load("sampleData.xml")
        Dim myPagedCollectionView As PagedCollectionView = Nothing
        Dim query = From c In xmldoc2.Descendants("情報") Select c

        For Each result In query
            With myPersonalInfo
                .Add(New PersonalInfo With {.氏名 = result.Element("氏名").Value,
                                           .年齢 = result.Element("年齢").Value,
                                           .住所 = result.Element("住所").Value,
                                           .勤務先 = result.Element("勤務先").Value})

            End With
            myPagedCollectionView = New PagedCollectionView(myPersonalInfo)
        Next
        PersonalInfo_DataGrid.ItemsSource = myPagedCollectionView
    End Sub

    Private Sub ImageShow()
        '■ListBoxに画像を表示させる処理
        Dim xmldoc3 As XElement = XElement.Load("Photo.xml")
        Dim imageQuery = From c In xmldoc3.Descendants("画像名") Select c
        Dim myImageInfo As New List(Of ImageInfo)
        For Each result In imageQuery
            myImageInfo.Add(New ImageInfo With {.画像名 = "Image/" & result.Value})
        Next
        Image_ListBox.ItemsSource = myImageInfo
    End Sub
End Class
